Skip to main content
POST
/
v1
/
w3s
/
user
/
wallets
Create wallets
curl --request POST \
  --url https://api.circle.com/v1/w3s/user/wallets \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --header 'X-User-Token: <x-user-token>' \
  --data '
{
  "idempotencyKey": "a0eebc99-9c0b-4ef8-bb6d-6bb9bd380a11",
  "blockchains": [
    "MATIC-AMOY"
  ],
  "metadata": [
    {
      "name": "<string>",
      "refId": "customer_12345"
    }
  ]
}
'
import requests

url = "https://api.circle.com/v1/w3s/user/wallets"

payload = {
"idempotencyKey": "a0eebc99-9c0b-4ef8-bb6d-6bb9bd380a11",
"blockchains": ["MATIC-AMOY"],
"metadata": [
{
"name": "<string>",
"refId": "customer_12345"
}
]
}
headers = {
"X-User-Token": "<x-user-token>",
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
const options = {
method: 'POST',
headers: {
'X-User-Token': '<x-user-token>',
Authorization: 'Bearer <token>',
'Content-Type': 'application/json'
},
body: JSON.stringify({
idempotencyKey: 'a0eebc99-9c0b-4ef8-bb6d-6bb9bd380a11',
blockchains: ['MATIC-AMOY'],
metadata: [{name: '<string>', refId: 'customer_12345'}]
})
};

fetch('https://api.circle.com/v1/w3s/user/wallets', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));


{
  "data": {
    "challengeId": "c4d1da72-111e-4d52-bdbf-2e74a2d803d5"
  }
}
{
"data": {
"challengeId": "c4d1da72-111e-4d52-bdbf-2e74a2d803d5"
}
}
{
"code": 400,
"message": "Bad request."
}
{
"code": 401,
"message": "Malformed authorization."
}

Authorizations

Authorization
string
header
required

Circle's API Keys are formatted in the following structure "PREFIX:ID:SECRET". All three parts are required to make a successful request.

Headers

X-User-Token
string
required

Unique system generated JWT session token for specific user.

X-Request-Id
string<uuid>

Developer-provided identifier for this request, used for tracing requests in Wallets API logs and the Developer Console, and when communicating with Circle Support. Must be a UUID to appear in logs. Non-UUID values are accepted by the API but are ignored by logging and tracing systems.

A unique identifier, which can be helpful for identifying a request when communicating with Circle support.

Example:

"2adba88e-9d63-44bc-b975-9b6ae3440dde"

Body

application/json

walletResponse creation request

idempotencyKey
string<uuid>
required

Universally unique identifier (UUID v4) idempotency key. This key is utilized to ensure exactly-once execution of mutating requests. To create a UUIDv4 go to uuidgenerator.net. If the same key is reused, it will be treated as the same request and the original response will be returned.

Example:

"a0eebc99-9c0b-4ef8-bb6d-6bb9bd380a11"

blockchains
enum<string>[]
required

Blockchain(s) the requested wallets will be created on.

The blockchain network that the resource is to be created on or is currently on.

Available options:
ETH,
ETH-SEPOLIA,
AVAX,
AVAX-FUJI,
MATIC,
MATIC-AMOY,
SOL,
SOL-DEVNET,
ARB,
ARB-SEPOLIA,
NEAR,
NEAR-TESTNET,
EVM,
EVM-TESTNET,
UNI,
UNI-SEPOLIA,
BASE,
BASE-SEPOLIA,
OP,
OP-SEPOLIA,
APTOS,
APTOS-TESTNET,
ARC-TESTNET,
MONAD,
MONAD-TESTNET
accountType
enum<string>

An account can be a Smart Contract Account (SCA) or an Externally Owned Account (EOA). To learn more, see the account types guide.

If an account type is not specified during the creation of a wallet, it defaults to EOA (Externally Owned Account). Note that Solana and Aptos don't support Smart Contract Account (SCA).

Available options:
SCA,
EOA
metadata
object[]

List of metadata fields to associate with the corresponding wallet.

Response

Returns the existing challenge if the idempotency key matches a previous successful request.

data
object